/*
    Copyright (C) 2002 Timo Sirainen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "common.h"
#include "commands.h"

int cmd_uid(Client *client)
{
	const char *cmd;

	/* UID <command> <args> */
	cmd = imap_parser_read_word(client->parser);
	if (cmd == NULL)
		return FALSE;

	client->cmd_func = NULL;
	switch (*cmd) {
	case 'c':
	case 'C':
		if (strcasecmp(cmd, "COPY") == 0)
			client->cmd_func = cmd_copy;
		break;
	case 'f':
	case 'F':
		if (strcasecmp(cmd, "FETCH") == 0)
			client->cmd_func = cmd_fetch;
		break;
	case 's':
	case 'S':
		if (strcasecmp(cmd, "STORE") == 0)
			client->cmd_func = cmd_store;
		else if (strcasecmp(cmd, "SEARCH") == 0)
			client->cmd_func = cmd_search;
		break;
	}

	if (client->cmd_func != NULL) {
		client->cmd_uid = TRUE;
		return client->cmd_func(client);
	} else {
		client_send_tagline(client, t_strconcat(
			"BAD Unknown UID command ", cmd, NULL));
		return TRUE;
	}
}
