#ifndef __MAILDIR_INDEX_H
#define __MAILDIR_INDEX_H

#include "mail-index.h"

/* ":2,DFRST" - leave the 2 extra for other clients' additions */
#define MAILDIR_LOCATION_EXTRA_SPACE 10

MailIndex *maildir_index_alloc(const char *dir);

const char *maildir_filename_set_flags(const char *fname, MailFlags flags);

int maildir_index_rebuild(MailIndex *index);
int maildir_index_sync(MailIndex *index);

int maildir_index_append_file(MailIndex *index, const char *dir,
			      const char *fname);
int maildir_index_build_dir(MailIndex *index, const char *source_dir,
			    const char *dest_dir);

int maildir_open_mail(MailIndex *index, MailIndexRecord *rec,
		      off_t *offset, size_t *size);

int maildir_record_update(MailIndex *index, MailIndexRecord *rec,
			  MailIndexUpdate *update, int fd, const char *path);

#endif
